package rndgenerator;

import java.io.*;
import java.net.*;
import java.nio.*;
import java.nio.channels.*;
import java.util.*;

public class RndServer {

    final static int port = 2005;
    final static int NEXT_RND = 1;

    Random rnd;
    
    public static void main(String[] args)
    {
        new RndServer().createConnection();
    }

    private boolean createConnection()
    {
        rnd = new Random();
        Socket socket;	
		    
        try {
            // first try to connect to other party, if it is already listening
                socket = new Socket("localhost", port);                    
                System.out.println("Server is already running");
                return false;
        } catch (Exception e) {}
            
        // otherwise create a listening socket and wait for the other party to connect
        System.out.println("Server started. Listening for clients.");
        try {
            Selector selector = Selector.open();
            ServerSocketChannel ssc1 = ServerSocketChannel.open();
            ssc1.configureBlocking( false );
            ServerSocket ss = ssc1.socket();
            InetSocketAddress address = new InetSocketAddress( port );
            ss.bind( address );
            
            
            SelectionKey key1 = ssc1.register( selector, SelectionKey.OP_ACCEPT );
            
            while (true)
            {
                // wait for a new connection or new request
                int num = selector.select();
                
                Set selectedKeys = selector.selectedKeys();
                Iterator it = selectedKeys.iterator();

                while (it.hasNext()) 
                {
                  SelectionKey key = (SelectionKey)it.next();
                  if ((key.readyOps() & SelectionKey.OP_ACCEPT) == SelectionKey.OP_ACCEPT)
                  {
                      System.out.println("New client arriving.");
                      ServerSocketChannel ssc = (ServerSocketChannel)key.channel();
                      SocketChannel sc = ssc.accept();	 
                      
                      sc.configureBlocking( false );
                      SelectionKey newKey = sc.register( selector, SelectionKey.OP_READ );                     
                  }
                  else if ((key.readyOps() & SelectionKey.OP_READ) == SelectionKey.OP_READ) 
                  {
                      // Read the data
                      SocketChannel sc = (SocketChannel)key.channel();
                      ByteBuffer rb = ByteBuffer.allocate(1);
                      sc.read(rb);
                      rb.flip();
                      if (NEXT_RND ==  rb.get())
                      {
                        ByteBuffer wb = ByteBuffer.allocate(10);
                        wb.putInt(rnd.nextInt());
                        wb.flip();
                        sc.write(wb);
                      }                      
                  }                  
                  it.remove();                  
                }
            }
        } catch (UnknownHostException e) {
                e.printStackTrace();
        } catch (IOException e) {
                e.printStackTrace();
        }
        return true;
    }
}
